<?php

/*
CREATE TABLE `Auth_UserRelation` (
  `ID` INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
  `User_ID` INT NOT NULL ,
  `Related_ID` INT NOT NULL ,
  `Type` INT NOT NULL ,
  `Created` DATETIME NOT NULL
) ENGINE = MYISAM 
*/

# const
define('NC_AUTH_FRIEND', 1);
define('NC_AUTH_BANNED', 2);

#user function

#   
/**
 *    
 *
 * @param int  (NC_AUTH_FRIEN  NC_AUTH_BANNED)
 * @param int Related_ID - ,   -
 * @param int User_ID - "" . (  -  )
 * @return int 0 -
 */
function nc_auth_add_relation ( $type, $Related_ID, $User_ID = 0 ) {
  global $db, $current_user;
  
  //    
  $type = intval($type);
  $Related_ID = intval($Related_ID);
  $User_ID = intval($User_ID);
  
  //  
  if ( !$User_ID ) $User_ID = $current_user['User_ID'];
  
  //   
  if ( 2 != $db->get_var("SELECT COUNT(`User_ID`) FROM `User` WHERE `User_ID` IN ('".$User_ID."', '".$Related_ID."')") ){
    return 0;
  }
  
  //    
  if ( nc_auth_is_friend($Related_ID, $User_ID, 1) ) return 0;
  if ( nc_auth_is_banned($Related_ID, $User_ID, 1) ) return 0;
 
  // 
  $db->insert_id = 0;
  $db->query("INSERT INTO `Auth_UserRelation`(`User_ID`, `Related_ID`, `Type`, `Created` )
              VALUES ('".$User_ID."', '".$Related_ID."', '".$type."', NOW())");
  
  return  $db->insert_id;
  
}


/**
 *  
 *
 * @param int $Related_ID
 * @param int $User_ID
 * @return int
 */
function nc_auth_add_friend ( $Related_ID, $User_ID = 0 ) {
  $type = NC_AUTH_FRIEND;
  return nc_auth_add_relation($type, $Related_ID, $User_ID);
}


/**
 *  
 *
 * @param int $Related_ID
 * @param int $User_ID
 * @return int
 */
function nc_auth_add_bann ( $Related_ID, $User_ID = 0 ) {
  $type = NC_AUTH_BANNED;
  return nc_auth_add_relation($type, $Related_ID, $User_ID);
}



#    

/**
 *    
 *
 * @param  int User_ID -  .   -  
 * @return array  [related_id] => type
 */
function nc_auth_get_all_relation( $User_ID = 0, $reset = 0) {
  global $db, $current_user;
  
  //  
  static $init;     //  
  static $relation; //   
  //    
  $User_ID = intval($User_ID);
  
  //   
  if ( !$User_ID ) $User_ID = $current_user['User_ID'];
  
  //   
  //if ( $db->get_var("SELECT `User_ID` FROM `User` WHERE `User_ID` = '".$User_ID."'") ){
  //  return 0;
  //}
  
  if ( $init[$User_ID] && !$reset) { //      
    return $relation[$User_ID];
  }
  
  //   
  $result = $db->get_results("SELECT `Related_ID`, `Type` FROM `Auth_UserRelation` WHERE `User_ID` = '".$User_ID."'", ARRAY_A);
  
  $init[$User_ID] = true;
  $relation[$User_ID] = array();
  
  //   
  if ( !empty($result) ) {
    foreach ( $result as $row ) {
      $relation[$User_ID][$row['Related_ID']] = $row['Type'];
    }
  }
  
  //  
  return $relation[$User_ID];
  
}

/**
 *   
 *
 * @param User_ID
 * @return array []=> User_ID
 */
function nc_auth_get_all_friend ( $User_ID = 0, $reset = 0 ) {
  //  
  $ret = array(); 
  //   
  $relation = nc_auth_get_all_relation($User_ID, $reset);
  
  //   
  if ( empty($relation) ) return $ret;
  
  //       
  foreach ( $relation as $related_id => $type) {
    if ( $type == NC_AUTH_FRIEND ) {
      $ret[] = $related_id;
    }
  }
  
  return $ret;
}



/**
 *   
 *
 * @param User_ID
 * @return array []=> User_ID
 */
function nc_auth_get_all_banned  ( $User_ID = 0, $reset = 0 ) {
  //  
  $ret = array(); 
  //   
  $relation = nc_auth_get_all_relation($User_ID, $reset);
  
  //   
  if ( empty($relation) ) return $ret;
  
  //       
  foreach ( $relation as $related_id => $type) {
    if ( $type == NC_AUTH_BANNED ) {
      $ret[] = $related_id;
    }
  }
  
  return $ret;
}


/**
 * ,    Related  User
 *
 * @param int $Related_ID
 * @param int $User_ID
 * @return bool
 */
function nc_auth_is_friend ( $Related_ID, $User_ID = 0, $reset = 0) {
  global $current_user;
  //   
  if ( !$User_ID ) $User_ID = $current_user['User_ID'];
  //   
  $friends = nc_auth_get_all_friend( $User_ID , $reset );
  
  return (!empty($friends) && in_array( $Related_ID, $friends));
}


/**
 * ,    Related  User
 *
 * @param int $Related_ID
 * @param int $User_ID
 * @return bool
 */
function nc_auth_is_banned ( $Related_ID, $User_ID = 0, $reset = 0) {
  global $current_user;
  //   
  if ( !$User_ID ) $User_ID = $current_user['User_ID'];
  //   
  $banned = nc_auth_get_all_banned( $User_ID, $reset );
  
  return (!empty($banned) && in_array( $Related_ID, $banned));
}


/**
 *    
 *
 * @param unknown_type $Related_ID
 * @param unknown_type $User_ID
 * @return unknown
 */
function nc_auth_get_relation ( $Related_ID, $User_ID = 0 , $reset = 0 ) {
  // is friend ?
  if ( nc_auth_is_friend($Related_ID, $User_ID, $reset) ) return NC_AUTH_FRIEND;
  // is banned ?
  if ( nc_auth_is_banned($Related_ID, $User_ID, $reset) ) return NC_AUTH_BANNED;
  
  return 0;

}

/**
 *   \ ?
 *
 * @param unknown_type $Related_ID
 * @param unknown_type $User_ID
 * @return int. NC_AUTH_FRIEND -  . NC_AUTH_BANNED -  
 */
function nc_auth_is_mutual  ( $Related_ID, $User_ID = 0, $reset = 0) {
  global $current_user;
  //   
  if ( !$User_ID ) $User_ID = $current_user['User_ID'];  
  
  //  
  if ( nc_auth_is_friend($Related_ID, $User_ID, $reset) && nc_auth_is_friend($User_ID, $Related_ID, $reset) ) return NC_AUTH_FRIEND;
  
  //  
  if ( nc_auth_is_banned($Related_ID, $User_ID, $reset) && nc_auth_is_banned($User_ID, $Related_ID, $reset) ) return NC_AUTH_BANNED;
  
  return 0;
}


#    

/**
 *    
 *
 * @param unknown_type $Related_ID
 * @param unknown_type $User_ID
 * @return unknown
 */
function nc_auth_delete_relation (  $Related_ID, $User_ID = 0) {
  global $current_user, $db;
  //   
  if ( !$User_ID ) $User_ID = $current_user['User_ID']; 
  
  $User_ID = intval($User_ID);
  $Related_ID = intval($Related_ID);
  
  $db->query("DELETE FROM `Auth_UserRelation` WHERE `User_ID` = '".$User_ID."' AND `Related_ID` = '".$Related_ID."'");
  
  return 0;
  
}
/**
 *   ,   
 *
 * @param mixed $User_ID array with ids or id
 */
function nc_auth_delete_all_relation ( $User_ID ) {
  global $db;
  
  if ( !is_array($User_ID) ) $User_ID = array($User_ID);
  
  if ( empty($User_ID) ) return false;
    
  $db->query("DELETE FROM `Auth_UserRelation`
              WHERE `User_ID` IN (".join(',', $User_ID).") 
              OR `Related_ID` IN (".join(',', $User_ID).") ");
  
  return true;
}


?>